% !TeX spellcheck = en_GB
Before applying any machine learning model to the data some preprocessing steps are required. First the data is filtered to separate the accelerometer into gravity and body components and remove the noise, see section \ref{ssec:filtering}, then, for the statical analysis, features are generated, section \ref{ssec:static_feat_gen}. After this the data is scaled (\ref{ssec:scaling}) and train and test sets are generated (\ref{ssec:tats}).


\subsection{Filtering}
\label{ssec:filtering}
As a first step the data needs to be filtered, especially the accelerometer measurements. Those measurements contain a lot of noise as well as a gravity component besides the actual body acceleration due to the activity. The gravity component, being a constant force with no rapid changes, can be extracted using a low-pass filter with a low cut-off frequency of \SI{0.25}{Hz}. \\
By using an additional high-pass filter with a cut-off frequency of \SI{20}{Hz} the noise component can be extracted. Subtracting the gravity and noise component from the actual accelerometer measurement leaves the body component for analysis. The actual implementation can be found in \textbf{filter\_acc\_data.py} and is displayed in the flow chart in figure \ref{img:data_filtering}. For this analysis a butterworth filter of 3rd order was used.

\begin{figure}[H]
	\centering
	\includegraphics[width=0.6\textwidth]{images/data_filtering.png}
	\caption{Data filtering flowchart}
	\label{img:data_filtering}
\end{figure}

The filtered result is exemplary shown in figures \ref{img:plot_acc_data_butterworth_filtered} and \ref{img:plot_acc_data_butterworth_filtered_walking_section} for the same user and experiment as used in figure \ref{img:line_chart_all_data_user_1_experiment_1} and \ref{img:line_chart_walking_user_1_exp_1.png}. It can be seen that the filtered body component has much less noise and is now centred around the zero axis, with the gravity component containing the slower and more steady changes.
\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{images/plot_acc_data_butterworth_filtered.png}
	\caption{Filtered accelerometer data for user 1 experiment 1}
	\label{img:plot_acc_data_butterworth_filtered}
\end{figure}

\begin{figure}[H]
	\centering
	\includegraphics[width=0.8\textwidth]{images/plot_acc_data_butterworth_filtered_walking_section.png}
	\caption{Filtered accelerometer data walking section user 1 experiment 1}
	\label{img:plot_acc_data_butterworth_filtered_walking_section}
\end{figure}

In section \ref{ssec:static_results} the accuracy of filtering and not filtering the data will be compared.


\subsection{Scaling}
\label{ssec:scaling}
For scaling the data the StandardScaler implementation by sklearn is used. Here each feature is scaled individually by subtracting the mean and dividing by the standard deviation, resulting in a standardized distribution with the scaled feature now having a mean of zero and a standard deviation of one.


\subsection{Train and test sets}
\label{ssec:tats}
After filtering and once all features were generated the data is split into a train and test sets. The train set is used to fit the model while the test set is used for checking its accuracy. It is important to apply certain actions only on the train data to avoid information leaking which could make the accuracy better then it would be for real unknown data. Those actions are for example scaling and feature selection algorithms, see \ref{ssec:scaling} and \ref{ssec:feature_selection}, were the fitting should be applied on the train data while the test data only gets transformed.\\
Normally a third data set would be advisable to prevent any over fitting on the test data. Here this is replaced by applying k-fold cross validation, see section \ref{ssec:static_modelselection}.



